"use strict";
const common_vendor = require("../../common/vendor.js");
const _sfc_main = {
  name: "IdentityVerify",
  data() {
    return {
      loading: false,
      responses: [],
      processedResponses: [],
      assistantResponse: "",
      audioTranscript: "",
      videoPlaying: false,
      showDebugInfo: false,
      // 设置为true可以显示调试信息
      videoUrl: "http://121.36.251.245:9000/minlong/0a0b3516-e0bb-4f6c-874c-8aaaca9d7f8f.mp4?X-Amz-Algorithm=AWS4-HMAC-SHA256&X-Amz-Credential=minioadmin%2F20250416%2Fus-east-1%2Fs3%2Faws4_request&X-Amz-Date=20250416T135206Z&X-Amz-Expires=3600&X-Amz-SignedHeaders=host&X-Amz-Signature=4a79bc77f80ae7344f339717dbe505a3b152140251a6b2c76c1fd5c047b39c74",
      // 用于存储AI数字人视频URL
      showReplayButton: false,
      cameraStream: null,
      // 存储摄像头流
      cameraError: null,
      // 存储摄像头错误信息
      useMiniProgramCameraComponent: false,
      // 添加小程序相机组件标志
      cameraContext: null,
      // 添加相机上下文
      currentSubtitle: "",
      subtitles: [
        {
          startTime: 0,
          // 开始时间（秒）
          endTime: 5,
          // 结束时间（秒）
          text: "你好，我是本次面试的面试官，欢迎参加本公司的线上面试!"
        },
        {
          startTime: 5,
          endTime: 13,
          text: "面试预计需要15分钟，请你提前安排在网络良好、光线亮度合适、且相对安静的环境参加这次面试"
        },
        {
          startTime: 13,
          endTime: 20,
          text: "以免影响本次面试的结果。如果你在面试过程中遇到问题，请与我们的招聘人员联系。"
        }
      ],
      secondVideoSubtitles: [
        {
          startTime: 0,
          endTime: 10,
          text: "请结合您的基本信息与过往履历进行简单的自我介绍，并讲一讲您有哪些优势胜任本岗位："
        }
      ],
      thirdVideoSubtitles: [
        {
          startTime: 0,
          endTime: 3,
          text: "在工作中，你如何确保个人防护装备的正确使用？"
        }
      ],
      fourthVideoSubtitles: [
        {
          startTime: 0,
          endTime: 3,
          text: "描述一次你与团队合作改善生产流程的经历。"
        }
      ],
      fifthVideoSubtitles: [
        {
          startTime: 0,
          endTime: 6,
          text: "你在团队合作中曾遇到过哪些挑战？如何解决团队内部的分歧？"
        }
      ],
      sixthVideoSubtitles: [
        {
          startTime: 0,
          endTime: 5,
          text: "您已完成本次面试全部题目，请问您对于这个岗位还有什么想要了解的吗？"
        }
      ],
      showAnswerButton: false,
      // 控制答题按钮显示
      currentVideoIndex: 0,
      // 当前播放的视频索引
      videoList: [
        "http://121.36.251.245:9000/minlong/0a0b3516-e0bb-4f6c-874c-8aaaca9d7f8f.mp4?X-Amz-Algorithm=AWS4-HMAC-SHA256&X-Amz-Credential=minioadmin%2F20250416%2Fus-east-1%2Fs3%2Faws4_request&X-Amz-Date=20250416T135206Z&X-Amz-Expires=3600&X-Amz-SignedHeaders=host&X-Amz-Signature=4a79bc77f80ae7344f339717dbe505a3b152140251a6b2c76c1fd5c047b39c74",
        // 第一段视频
        "http://121.36.251.245:9000/minlong/9ab3fd68-a2e9-47a7-a05e-a6e2253ef22c.mp4?X-Amz-Algorithm=AWS4-HMAC-SHA256&X-Amz-Credential=minioadmin%2F20250416%2Fus-east-1%2Fs3%2Faws4_request&X-Amz-Date=20250416T143129Z&X-Amz-Expires=3600&X-Amz-SignedHeaders=host&X-Amz-Signature=7a0ebf1058252b5f76895b31a5293d4781b33ede63d32dce148350846aa20621",
        // 第二段视频
        "http://121.36.251.245:9000/minlong/69406ce9-8d8e-48aa-ba2f-3b12ea5b6a6c.mp4?X-Amz-Algorithm=AWS4-HMAC-SHA256&X-Amz-Credential=minioadmin%2F20250416%2Fus-east-1%2Fs3%2Faws4_request&X-Amz-Date=20250416T144114Z&X-Amz-Expires=3600&X-Amz-SignedHeaders=host&X-Amz-Signature=a43a06217a63f9bb6af975b1a7aa419b6f8e3d77d8c6c9c67d1070edfe60dc43",
        // 第三段视频
        "http://121.36.251.245:9000/minlong/1cd448b2-16ea-4565-be25-2cf71d1bf7b2.mp4?X-Amz-Algorithm=AWS4-HMAC-SHA256&X-Amz-Credential=minioadmin%2F20250416%2Fus-east-1%2Fs3%2Faws4_request&X-Amz-Date=20250416T144554Z&X-Amz-Expires=3600&X-Amz-SignedHeaders=host&X-Amz-Signature=6ef5b0b160feab053e7d95952cdac62266d1a1eb48999efb17d7a3c4e0b495ed",
        "http://121.36.251.245:9000/minlong/5a9ad6b2-0de8-48e3-8eb7-141a9bee4a9b.mp4?X-Amz-Algorithm=AWS4-HMAC-SHA256&X-Amz-Credential=minioadmin%2F20250416%2Fus-east-1%2Fs3%2Faws4_request&X-Amz-Date=20250416T145623Z&X-Amz-Expires=3600&X-Amz-SignedHeaders=host&X-Amz-Signature=8a2120a4c6b059d64f90620377fdda2536f9fff9c455d5140210ef35990758c6",
        "http://121.36.251.245:9000/minlong/7aafb07e-ab0d-477e-9124-3263d0b7bf6f.mp4?X-Amz-Algorithm=AWS4-HMAC-SHA256&X-Amz-Credential=minioadmin%2F20250416%2Fus-east-1%2Fs3%2Faws4_request&X-Amz-Date=20250416T145857Z&X-Amz-Expires=3600&X-Amz-SignedHeaders=host&X-Amz-Signature=54ebe67d751c7e44a0f608b26175c9d076685a0e647e7e134cda22bbca2639eb"
        //结束
      ],
      isRecording: false,
      recordingTimer: null,
      showStopRecordingButton: false,
      mediaRecorder: null,
      recordedChunks: [],
      recorder: null,
      lastUploadedVideoUrl: "",
      showStartRecordingButton: false
    };
  },
  mounted() {
    this.playDigitalHumanVideo();
    this.checkAudioPermission();
    this.initCamera();
    setTimeout(() => {
      if (this.cameraStream && !this.useMiniProgramCameraComponent) {
        this.testAudioInput();
      }
    }, 3e3);
  },
  beforeDestroy() {
    this.stopUserCamera();
  },
  methods: {
    // 初始化相机
    async initCamera() {
      const systemInfo = common_vendor.index.getSystemInfoSync();
      const isMiniProgram = systemInfo.uniPlatform === "mp-weixin" || systemInfo.uniPlatform === "mp-alipay" || systemInfo.uniPlatform === "mp-baidu";
      if (isMiniProgram) {
        this.useMiniProgramCameraComponent = true;
        this.cameraContext = common_vendor.index.createCameraContext();
        common_vendor.index.getSetting({
          success: (res) => {
            if (!res.authSetting["scope.record"]) {
              common_vendor.index.authorize({
                scope: "scope.record",
                success: () => {
                  console.log("录音权限已获取");
                },
                fail: (err) => {
                  console.error("录音权限获取失败:", err);
                  this.showPermissionDialog("录音");
                }
              });
            }
            if (!res.authSetting["scope.camera"]) {
              common_vendor.index.authorize({
                scope: "scope.camera",
                success: () => {
                  console.log("相机权限已获取");
                },
                fail: (err) => {
                  console.error("相机权限获取失败:", err);
                  this.showPermissionDialog("相机");
                }
              });
            }
          }
        });
      } else {
        try {
          const constraints = {
            audio: {
              echoCancellation: true,
              noiseSuppression: true,
              autoGainControl: true
            },
            video: {
              width: { ideal: 640 },
              height: { ideal: 480 },
              facingMode: "user"
            }
          };
          const stream = await navigator.mediaDevices.getUserMedia(constraints);
          this.cameraStream = stream;
          const audioTracks = stream.getAudioTracks();
          console.log("音频轨道数量:", audioTracks.length);
          if (audioTracks.length > 0) {
            console.log("音频轨道已获取:", audioTracks[0].label);
            audioTracks[0].enabled = true;
          } else {
            console.warn("未检测到音频轨道，尝试单独获取音频");
            this.tryGetAudioOnly();
          }
          const videoElement = this.$refs.userCameraVideo;
          if (videoElement) {
            videoElement.srcObject = stream;
            videoElement.muted = true;
          }
        } catch (error) {
          console.error("获取摄像头失败:", error);
          this.cameraError = error.message || "无法访问摄像头";
          common_vendor.index.showToast({
            title: "无法访问摄像头，请检查权限设置",
            icon: "none"
          });
        }
      }
    },
    // 停止用户摄像头
    stopUserCamera() {
      if (this.cameraStream) {
        this.cameraStream.getTracks().forEach((track) => {
          track.stop();
        });
        this.cameraStream = null;
      }
    },
    async fetchData() {
      this.loading = true;
      this.assistantResponse = "";
      this.audioTranscript = "";
      this.processedResponses = [];
      try {
        const requestTask = common_vendor.index.request({
          url: "https://dashscope.aliyuncs.com/compatible-mode/v1/chat/completions",
          method: "POST",
          header: {
            "Content-Type": "application/json",
            "Authorization": "Bearer sk-9e1ec73a7d97493b8613c63f06b6110c"
          },
          data: {
            "model": "qwen-omni-turbo",
            "messages": [
              {
                "role": "user",
                "content": [
                  {
                    "type": "input_audio",
                    "input_audio": {
                      "data": "https://help-static-aliyun-doc.aliyuncs.com/file-manage-files/zh-CN/20250211/tixcef/cherry.wav",
                      "format": "wav"
                    }
                  },
                  {
                    "type": "text",
                    "text": "这段音频在说什么"
                  }
                ]
              }
            ],
            "stream": true,
            "stream_options": {
              "include_usage": true
            },
            "modalities": ["text", "audio"],
            "audio": { "voice": "Cherry", "format": "wav" }
          },
          success: (res) => {
            console.log("请求成功，响应数据:", res.data);
            if (typeof res.data === "string" && res.data.includes("data: {")) {
              const chunks = res.data.split("data: ").filter((chunk) => chunk.trim() !== "");
              chunks.forEach((chunk) => {
                this.handleStreamResponse(chunk);
              });
            } else {
              this.handleStreamResponse(res.data);
            }
            this.playDigitalHumanVideo();
          },
          fail: (err) => {
            console.error("请求失败:", err);
          },
          complete: () => {
            this.loading = false;
          }
        });
      } catch (error) {
        console.error("获取数据失败:", error);
        this.loading = false;
      }
    },
    handleStreamResponse(data) {
      if (typeof data === "string") {
        if (data === "[DONE]")
          return;
        try {
          const cleanData = data.trim();
          if (cleanData.startsWith("{") && cleanData.endsWith("}")) {
            const jsonData = JSON.parse(cleanData);
            this.processStreamChunk(jsonData);
          }
        } catch (e) {
          console.error("解析JSON失败:", e, "原始数据:", data);
        }
      } else {
        this.processStreamChunk(data);
      }
    },
    processStreamChunk(chunk) {
      if (chunk.choices && chunk.choices.length > 0) {
        const choice = chunk.choices[0];
        if (choice.delta && choice.delta.content) {
          this.assistantResponse += choice.delta.content;
        }
        if (choice.delta && choice.delta.audio && choice.delta.audio.transcript) {
          this.audioTranscript += choice.delta.audio.transcript;
        }
        if (choice.delta) {
          const result = {};
          if (choice.delta.role) {
            result.role = choice.delta.role;
          }
          if (choice.delta.audio && choice.delta.audio.transcript) {
            result.transcript = choice.delta.audio.transcript;
          }
          if (Object.keys(result).length > 0) {
            this.processedResponses.push(result);
          }
        }
      }
    },
    processResponseData() {
      this.processedResponses = this.responses.map((item) => {
        const result = {};
        if (item.delta && item.delta.role) {
          result.role = item.delta.role;
        }
        if (item.delta && item.delta.audio && item.delta.audio.transcript) {
          result.transcript = item.delta.audio.transcript;
        }
        return result;
      }).filter((item) => Object.keys(item).length > 0);
    },
    // 播放数字人视频
    playDigitalHumanVideo() {
      this.videoUrl = this.videoList[this.currentVideoIndex];
      this.videoPlaying = true;
      this.$nextTick(() => {
        const videoContext = common_vendor.index.createVideoContext("myVideo", this);
        if (videoContext) {
          videoContext.play();
          setTimeout(() => {
            if (this.videoPlaying && this.$refs.videoPlayer) {
              console.log("视频应该正在播放");
            } else {
              console.log("视频可能未成功播放，尝试替代方案");
              this.tryAlternativeVideoPath();
            }
          }, 1e3);
        } else {
          console.error("无法创建视频上下文");
          this.tryAlternativeVideoPath();
        }
      });
    },
    // 修改 tryAlternativeVideoPath 方法
    tryAlternativeVideoPath() {
      console.log("尝试使用替代路径");
      const alternativePaths = [
        "./static/demo.mp4",
        "../static/demo.mp4",
        "static/demo.mp4",
        "/static/demo.mp4",
        // 添加绝对路径
        `${window.location.origin}/static/demo.mp4`
      ];
      const currentPathIndex = alternativePaths.indexOf(this.videoUrl);
      const nextPathIndex = (currentPathIndex + 1) % alternativePaths.length;
      this.videoUrl = alternativePaths[nextPathIndex];
      console.log("尝试新路径:", this.videoUrl);
      this.$nextTick(() => {
        const videoContext = common_vendor.index.createVideoContext("myVideo", this);
        if (videoContext) {
          videoContext.stop();
          videoContext.play();
          setTimeout(() => {
            if (nextPathIndex === alternativePaths.length - 1 && !this.videoPlaying) {
              console.log("所有路径均失败，尝试使用uni.getVideoInfo检查视频");
              this.checkVideoWithAPI();
            }
          }, 1e3);
        }
      });
    },
    // 添加新方法：使用uni API检查视频
    checkVideoWithAPI() {
      common_vendor.index.getVideoInfo({
        src: "/static/demo.mp4",
        success: (res) => {
          console.log("视频信息获取成功:", res);
          this.videoUrl = "/static/demo.mp4";
          this.$nextTick(() => {
            const videoContext = common_vendor.index.createVideoContext("myVideo", this);
            if (videoContext) {
              videoContext.play();
            }
          });
        },
        fail: (err) => {
          console.error("视频信息获取失败:", err);
          this.fallbackToLocalVideo();
        }
      });
    },
    // 添加新方法：回退到本地视频
    fallbackToLocalVideo() {
      console.log("尝试使用本地视频资源");
      const platform = common_vendor.index.getSystemInfoSync().platform;
      if (platform === "android" || platform === "ios") {
        this.videoUrl = platform === "android" ? "android.resource://package_name/raw/demo" : "file:///assets/demo.mp4";
        this.$nextTick(() => {
          const videoContext = common_vendor.index.createVideoContext("myVideo", this);
          if (videoContext) {
            videoContext.play();
          }
        });
      } else {
        this.videoPlaying = false;
        common_vendor.index.showToast({
          title: "视频加载失败，显示静态图片",
          icon: "none"
        });
      }
    },
    // 修改 handleVideoError 方法
    handleVideoError(e) {
      console.error("视频加载错误:", e);
      if (e && e.detail) {
        console.error("详细错误信息:", e.detail);
      }
      common_vendor.index.getFileInfo({
        filePath: this.videoUrl.startsWith("/") ? this.videoUrl.substring(1) : this.videoUrl,
        success: (res) => {
          console.log("文件存在，大小:", res.size);
          this.tryDifferentFormat();
        },
        fail: (err) => {
          console.error("文件不存在或无法访问:", err);
          this.tryAlternativeVideoPath();
        }
      });
      common_vendor.index.showToast({
        title: "视频加载失败，请检查文件是否存在",
        icon: "none",
        duration: 2e3
      });
    },
    // 添加新方法：尝试不同格式
    tryDifferentFormat() {
      console.log("尝试不同的视频格式");
      const formats = [
        { ext: "mp4", mime: "video/mp4" },
        { ext: "webm", mime: "video/webm" },
        { ext: "ogg", mime: "video/ogg" },
        { ext: "mov", mime: "video/quicktime" }
      ];
      const currentPath = this.videoUrl;
      const basePath = currentPath.substring(0, currentPath.lastIndexOf(".")) || "/static/demo";
      let nextFormat = formats.find((f) => !currentPath.endsWith(f.ext));
      if (nextFormat) {
        this.videoUrl = `${basePath}.${nextFormat.ext}`;
        console.log("尝试新格式:", this.videoUrl);
        this.$nextTick(() => {
          const videoContext = common_vendor.index.createVideoContext("myVideo", this);
          if (videoContext) {
            videoContext.stop();
            videoContext.play();
          }
        });
      } else {
        this.useBuiltInResource();
      }
    },
    // 添加新方法：使用内置资源
    useBuiltInResource() {
      console.log("尝试使用内置资源");
      const platform = common_vendor.index.getSystemInfoSync().platform;
      if (platform === "windows") {
        process.env.UNI_INPUT_DIR || "";
        this.videoUrl = `./static/demo.mp4`;
        console.log("Windows平台尝试路径:", this.videoUrl);
      } else if (platform === "android" || platform === "ios") {
        this.useNativeVideo();
      } else {
        const baseUrl = window.location.origin;
        this.videoUrl = `${baseUrl}/static/demo.mp4`;
        console.log("Web平台尝试URL:", this.videoUrl);
      }
      this.$nextTick(() => {
        const videoContext = common_vendor.index.createVideoContext("myVideo", this);
        if (videoContext) {
          videoContext.play();
        }
      });
    },
    // 添加新方法：使用原生视频能力
    useNativeVideo() {
      console.log("尝试使用原生视频能力");
      common_vendor.index.chooseVideo({
        sourceType: ["album"],
        success: (res) => {
          this.videoUrl = res.tempFilePath;
          this.$nextTick(() => {
            const videoContext = common_vendor.index.createVideoContext("myVideo", this);
            if (videoContext) {
              videoContext.play();
            }
          });
        },
        fail: () => {
          this.videoPlaying = false;
          common_vendor.index.showToast({
            title: "无法加载视频，显示静态图片",
            icon: "none"
          });
        }
      });
    },
    // 处理视频结束事件
    handleVideoEnded() {
      console.log("视频播放结束");
      this.videoPlaying = false;
      if (this.currentVideoIndex >= 1) {
        this.showStartRecordingButton = true;
      } else {
        this.showAnswerButton = true;
      }
    },
    // 添加新方法：开始录制用户回答
    startRecordingAnswer() {
      console.log("开始录制用户回答");
      this.isRecording = true;
      const systemInfo = common_vendor.index.getSystemInfoSync();
      const isMiniProgram = systemInfo.uniPlatform && systemInfo.uniPlatform.startsWith("mp-");
      if (isMiniProgram) {
        this.startMiniProgramRecording();
      } else {
        this.startBrowserRecording();
      }
      this.showStopRecordingButton = true;
    },
    // 修改小程序环境下的录制方法
    startMiniProgramRecording() {
      if (!this.cameraContext) {
        this.cameraContext = common_vendor.index.createCameraContext();
      }
      common_vendor.index.getSetting({
        success: (res) => {
          const hasRecordAuth = res.authSetting["scope.record"];
          const hasCameraAuth = res.authSetting["scope.camera"];
          if (!hasRecordAuth || !hasCameraAuth) {
            console.warn("缺少必要权限，请求权限");
            this.requestMiniProgramPermissions();
            return;
          }
          const options = {
            timeout: 6e4,
            // 最长录制60秒
            success: () => {
              console.log("小程序录像开始成功");
            },
            fail: (err) => {
              console.error("小程序录像开始失败:", err);
              common_vendor.index.showToast({
                title: "录制失败，请检查相机权限",
                icon: "none"
              });
              this.proceedToNextQuestion();
            },
            timeoutCallback: () => {
              console.log("录制超时自动停止");
              this.stopRecordingAnswer();
            }
          };
          this.recorder = this.cameraContext.startRecord(options);
        }
      });
    },
    // 添加新方法：请求小程序权限
    requestMiniProgramPermissions() {
      common_vendor.index.authorize({
        scope: "scope.record",
        success: () => {
          console.log("录音权限已获取");
          common_vendor.index.authorize({
            scope: "scope.camera",
            success: () => {
              console.log("相机权限已获取");
              this.startMiniProgramRecording();
            },
            fail: (err) => {
              console.error("相机权限获取失败:", err);
              this.showPermissionDialog("相机");
            }
          });
        },
        fail: (err) => {
          console.error("录音权限获取失败:", err);
          this.showPermissionDialog("录音");
        }
      });
    },
    // 修改浏览器环境下的录制方法
    startBrowserRecording() {
      if (!this.cameraStream) {
        console.error("没有可用的摄像头流");
        common_vendor.index.showToast({
          title: "录制失败，摄像头未就绪",
          icon: "none"
        });
        this.proceedToNextQuestion();
        return;
      }
      try {
        const hasAudio = this.cameraStream.getAudioTracks().length > 0;
        if (!hasAudio) {
          console.warn("警告：媒体流中没有音频轨道，尝试重新获取带音频的媒体流");
          navigator.mediaDevices.getUserMedia({
            audio: {
              echoCancellation: true,
              noiseSuppression: true,
              autoGainControl: true
            },
            video: true
          }).then((newStream) => {
            const audioTracks = newStream.getAudioTracks();
            if (audioTracks.length > 0) {
              console.log("成功获取音频轨道:", audioTracks[0].label);
              const videoTrack = this.cameraStream.getVideoTracks()[0];
              const audioTrack = newStream.getAudioTracks()[0];
              const combinedStream = new MediaStream();
              if (videoTrack)
                combinedStream.addTrack(videoTrack);
              if (audioTrack)
                combinedStream.addTrack(audioTrack);
              this.cameraStream = combinedStream;
              const videoElement = this.$refs.userCameraVideo;
              if (videoElement) {
                videoElement.srcObject = combinedStream;
                videoElement.muted = true;
              }
              this.setupMediaRecorder(combinedStream);
            } else {
              console.warn("仍然无法获取音频轨道");
              this.setupMediaRecorder(this.cameraStream);
            }
          }).catch((err) => {
            console.error("获取音频失败:", err);
            this.setupMediaRecorder(this.cameraStream);
          });
        } else {
          console.log("检测到音频轨道，直接使用");
          this.setupMediaRecorder(this.cameraStream);
        }
      } catch (error) {
        console.error("浏览器录制失败:", error);
        common_vendor.index.showToast({
          title: "录制失败，浏览器可能不支持此功能",
          icon: "none"
        });
        this.proceedToNextQuestion();
      }
    },
    // 修改 setupMediaRecorder 方法
    setupMediaRecorder(stream) {
      const videoTracks = stream.getVideoTracks();
      const audioTracks = stream.getAudioTracks();
      console.log("设置MediaRecorder - 视频轨道:", videoTracks.length, "音频轨道:", audioTracks.length);
      let mimeType = "";
      const supportedTypes = [
        "video/webm;codecs=vp9,opus",
        "video/webm;codecs=vp8,opus",
        "video/webm;codecs=h264,opus",
        "video/mp4;codecs=h264,aac",
        "video/webm",
        "video/mp4"
      ];
      for (const type of supportedTypes) {
        if (MediaRecorder.isTypeSupported(type)) {
          mimeType = type;
          console.log("使用支持的MIME类型:", mimeType);
          break;
        }
      }
      const options = {
        mimeType: mimeType || "",
        audioBitsPerSecond: 128e3,
        videoBitsPerSecond: 25e5
      };
      try {
        this.mediaRecorder = new MediaRecorder(stream, options);
        console.log("MediaRecorder创建成功，使用选项:", options);
      } catch (e) {
        console.warn("使用指定选项创建MediaRecorder失败，尝试使用默认选项");
        this.mediaRecorder = new MediaRecorder(stream);
      }
      this.recordedChunks = [];
      this.mediaRecorder.ondataavailable = (event) => {
        if (event.data && event.data.size > 0) {
          this.recordedChunks.push(event.data);
          console.log(`收到数据块: ${event.data.size} 字节`);
        }
      };
      this.mediaRecorder.onstop = () => {
        console.log("MediaRecorder停止，数据块数量:", this.recordedChunks.length);
        if (this.recordedChunks.length === 0) {
          console.error("没有录制到数据");
          common_vendor.index.showToast({
            title: "录制失败，未捕获到数据",
            icon: "none"
          });
          this.proceedToNextQuestion();
          return;
        }
        const mimeType2 = this.mediaRecorder.mimeType || "video/webm";
        const blob = new Blob(this.recordedChunks, { type: mimeType2 });
        console.log("创建Blob，大小:", blob.size, "类型:", mimeType2);
        const fileName = `answer_${this.currentVideoIndex}_${Date.now()}.webm`;
        const file = new File([blob], fileName, { type: mimeType2 });
        this.uploadRecordedVideo(file);
      };
      this.mediaRecorder.onerror = (event) => {
        console.error("MediaRecorder错误:", event.error);
      };
      try {
        this.mediaRecorder.start(1e3);
        console.log("MediaRecorder开始录制");
      } catch (e) {
        console.error("开始录制失败:", e);
      }
    },
    // 添加新方法：停止录制用户回答
    stopRecordingAnswer() {
      console.log("停止录制用户回答");
      this.isRecording = false;
      if (this.recordingTimer) {
        clearTimeout(this.recordingTimer);
        this.recordingTimer = null;
      }
      common_vendor.index.hideLoading();
      this.showStopRecordingButton = false;
      const systemInfo = common_vendor.index.getSystemInfoSync();
      const isMiniProgram = systemInfo.uniPlatform && systemInfo.uniPlatform.startsWith("mp-");
      if (isMiniProgram) {
        this.stopMiniProgramRecording();
      } else {
        this.stopBrowserRecording();
      }
    },
    // 添加新方法：停止小程序录制
    stopMiniProgramRecording() {
      if (!this.cameraContext) {
        console.error("相机上下文不存在");
        this.proceedToNextQuestion();
        return;
      }
      this.cameraContext.stopRecord({
        success: (res) => {
          console.log("小程序录像停止成功:", res);
          const tempFilePath = res.tempVideoPath;
          this.uploadRecordedVideo(tempFilePath);
        },
        fail: (err) => {
          console.error("小程序录像停止失败:", err);
          common_vendor.index.showToast({
            title: "录制失败",
            icon: "none"
          });
          this.proceedToNextQuestion();
        }
      });
    },
    // 添加新方法：停止浏览器录制
    stopBrowserRecording() {
      if (this.mediaRecorder && this.mediaRecorder.state !== "inactive") {
        this.mediaRecorder.stop();
        console.log("浏览器录制停止成功");
      } else {
        console.error("MediaRecorder不存在或已经停止");
        this.proceedToNextQuestion();
      }
    },
    // 修改上传录制的视频方法
    uploadRecordedVideo(fileOrPath) {
      console.log("准备上传视频:", typeof fileOrPath === "string" ? fileOrPath : fileOrPath.name);
      common_vendor.index.showLoading({
        title: "正在上传...",
        mask: true
      });
      const userInfo = common_vendor.index.getStorageSync("userInfo");
      const openid = userInfo ? JSON.parse(userInfo).openid || "" : "";
      const tenant_id = common_vendor.index.getStorageSync("tenant_id") || "1";
      if (typeof fileOrPath !== "string") {
        const formData = new FormData();
        formData.append("file", fileOrPath);
        formData.append("openid", openid);
        formData.append("tenant_id", tenant_id);
        formData.append("application_id", 1);
        formData.append("question_id", this.currentVideoIndex);
        formData.append("video_duration", 0);
        formData.append("has_audio", "true");
        const xhr = new XMLHttpRequest();
        xhr.open("POST", "http://192.168.66.187:8083/api/system/upload/", true);
        xhr.onload = () => {
          common_vendor.index.hideLoading();
          if (xhr.status === 200) {
            try {
              const res = JSON.parse(xhr.responseText);
              console.log("上传响应:", res);
              if (res.code === 2e3) {
                const videoUrl = res.data.url || res.data.photoUrl || "";
                if (videoUrl) {
                  this.submitVideoToInterview(videoUrl);
                } else {
                  common_vendor.index.showToast({
                    title: "视频URL获取失败",
                    icon: "none"
                  });
                }
              } else {
                common_vendor.index.showToast({
                  title: res.msg || "上传失败，请重试",
                  icon: "none"
                });
              }
            } catch (e) {
              console.error("解析响应失败:", e);
              common_vendor.index.showToast({
                title: "解析响应失败",
                icon: "none"
              });
            }
          } else {
            common_vendor.index.showToast({
              title: "上传失败，HTTP状态: " + xhr.status,
              icon: "none"
            });
          }
        };
        xhr.onerror = () => {
          common_vendor.index.hideLoading();
          console.error("上传网络错误");
          common_vendor.index.showToast({
            title: "网络错误，请重试",
            icon: "none"
          });
        };
        xhr.upload.onprogress = (event) => {
          if (event.lengthComputable) {
            const percentComplete = Math.round(event.loaded / event.total * 100);
            console.log("上传进度:", percentComplete + "%");
          }
        };
        xhr.send(formData);
        return;
      }
      common_vendor.index.uploadFile({
        url: "http://192.168.66.187:8083/api/system/upload/",
        filePath: fileOrPath,
        name: "file",
        formData: {
          openid,
          tenant_id,
          application_id: 1,
          question_id: this.currentVideoIndex,
          video_duration: 0,
          has_audio: "true"
          // 明确标记视频包含音频
        },
        success: (uploadRes) => {
          try {
            const res = JSON.parse(uploadRes.data);
            console.log("上传响应:", res);
            if (res.code === 2e3) {
              const videoUrl = res.data.url || res.data.photoUrl || "";
              if (videoUrl) {
                this.submitVideoToInterview(videoUrl);
              } else {
                common_vendor.index.showToast({
                  title: "视频URL获取失败",
                  icon: "none"
                });
              }
            } else {
              common_vendor.index.showToast({
                title: res.msg || "上传失败，请重试",
                icon: "none"
              });
            }
          } catch (e) {
            console.error("解析响应失败:", e);
            common_vendor.index.showToast({
              title: "解析响应失败",
              icon: "none"
            });
          }
        },
        fail: (err) => {
          console.error("上传失败:", err);
          common_vendor.index.showToast({
            title: "上传失败，请重试",
            icon: "none"
          });
        },
        complete: () => {
          common_vendor.index.hideLoading();
        }
      });
    },
    // 添加新方法：将视频URL提交到面试接口
    submitVideoToInterview(videoUrl) {
      console.log("提交视频URL到面试接口:", videoUrl);
      const requestData = {
        application_id: 1,
        question_id: this.currentVideoIndex,
        video_url: videoUrl,
        video_duration: 0,
        tenant_id: common_vendor.index.getStorageSync("tenant_id") || "1"
      };
      common_vendor.index.request({
        url: "http://192.168.66.187:8083/api/job/upload_video",
        method: "POST",
        data: requestData,
        header: {
          "content-type": "application/json"
        },
        success: (res) => {
          console.log("面试接口提交成功:", res);
          common_vendor.index.hideLoading();
          if (res.data.code === 0 || res.data.code === 2e3) {
            common_vendor.index.showToast({
              title: "回答已提交",
              icon: "success"
            });
            this.lastUploadedVideoUrl = videoUrl;
            setTimeout(() => {
              this.proceedToNextQuestion();
            }, 1500);
          } else {
            common_vendor.index.showToast({
              title: res.data.msg || "提交失败，请重试",
              icon: "none"
            });
          }
        },
        fail: (err) => {
          console.error("面试接口提交失败:", err);
          common_vendor.index.hideLoading();
          common_vendor.index.showToast({
            title: "网络错误，请重试",
            icon: "none"
          });
        }
      });
    },
    // 添加新方法：进入下一个问题
    proceedToNextQuestion() {
      this.currentVideoIndex++;
      if (this.currentVideoIndex < this.videoList.length) {
        this.videoUrl = this.videoList[this.currentVideoIndex];
        this.videoPlaying = true;
        this.currentSubtitle = "";
        this.$nextTick(() => {
          const videoContext = common_vendor.index.createVideoContext("myVideo", this);
          if (videoContext) {
            videoContext.play();
          }
        });
      } else {
        common_vendor.index.showToast({
          title: "面试完成",
          icon: "success",
          duration: 2e3
        });
        setTimeout(() => {
          common_vendor.index.navigateTo({
            url: "/pages/interview-result/interview-result"
          });
        }, 2e3);
      }
    },
    // 修改 handleAnswerButtonClick 方法
    handleAnswerButtonClick() {
      this.showAnswerButton = false;
      this.proceedToNextQuestion();
    },
    // 处理相机错误
    handleCameraError(e) {
      console.error("相机错误:", e);
      common_vendor.index.showToast({
        title: "相机初始化失败，请检查权限设置",
        icon: "none"
      });
      this.tryFallbackOptions();
    },
    // 添加新方法：尝试备用选项
    tryFallbackOptions() {
      const systemInfo = common_vendor.index.getSystemInfoSync();
      if (systemInfo.uniPlatform === "mp-weixin" || systemInfo.uniPlatform === "mp-alipay") {
        this.useMiniProgramCamera();
      } else {
        this.showStaticCameraPlaceholder();
      }
    },
    // 添加新方法：使用小程序相机API
    useMiniProgramCamera() {
      console.log("尝试使用小程序相机组件");
      this.useMiniProgramCameraComponent = true;
    },
    // 添加新方法：显示静态图像
    showStaticCameraPlaceholder() {
      console.log("显示静态摄像头占位图");
      const img = document.createElement("img");
      img.src = "/static/images/camera-placeholder.png";
      img.className = "static-camera-image";
      img.style.width = "100%";
      img.style.height = "100%";
      img.style.objectFit = "cover";
      const container = this.$refs.userCameraVideo.parentNode;
      container.appendChild(img);
    },
    // 处理视频时间更新事件
    handleTimeUpdate(e) {
      const currentTime = e.target.currentTime;
      let currentSubtitles;
      if (this.currentVideoIndex === 0) {
        currentSubtitles = this.subtitles;
      } else if (this.currentVideoIndex === 1) {
        currentSubtitles = this.secondVideoSubtitles;
      } else if (this.currentVideoIndex === 2) {
        currentSubtitles = this.thirdVideoSubtitles;
      } else if (this.currentVideoIndex === 3) {
        currentSubtitles = this.fourthVideoSubtitles;
      } else if (this.currentVideoIndex === 4) {
        currentSubtitles = this.fifthVideoSubtitles;
      } else if (this.currentVideoIndex === 5) {
        currentSubtitles = this.sixthVideoSubtitles;
      } else {
        currentSubtitles = [];
      }
      const subtitle = currentSubtitles.find(
        (sub) => currentTime >= sub.startTime && currentTime < sub.endTime
      );
      this.currentSubtitle = subtitle ? subtitle.text : "";
    },
    // Add a new method to handle the "Start Recording" button click
    handleStartRecordingClick() {
      this.showStartRecordingButton = false;
      this.startRecordingAnswer();
    },
    // 修改 checkAudioPermission 方法，确保在录制前获取音频权限
    checkAudioPermission() {
      const systemInfo = common_vendor.index.getSystemInfoSync();
      const isMiniProgram = systemInfo.uniPlatform && systemInfo.uniPlatform.startsWith("mp-");
      if (isMiniProgram) {
        common_vendor.index.getSetting({
          success: (res) => {
            if (!res.authSetting["scope.record"]) {
              common_vendor.index.authorize({
                scope: "scope.record",
                success: () => {
                  console.log("录音权限已获取");
                },
                fail: (err) => {
                  console.error("录音权限获取失败:", err);
                  this.showPermissionDialog("录音");
                }
              });
            }
            if (!res.authSetting["scope.camera"]) {
              common_vendor.index.authorize({
                scope: "scope.camera",
                success: () => {
                  console.log("相机权限已获取");
                },
                fail: (err) => {
                  console.error("相机权限获取失败:", err);
                  this.showPermissionDialog("相机");
                }
              });
            }
          }
        });
      }
    },
    // 添加新方法：测试音频输入
    testAudioInput() {
      if (!this.cameraStream) {
        console.warn("没有可用的媒体流，无法测试音频");
        return;
      }
      const audioTracks = this.cameraStream.getAudioTracks();
      if (audioTracks.length === 0) {
        console.warn("没有检测到音频轨道，尝试重新获取");
        this.tryGetAudioOnly();
        return;
      }
      console.log("音频轨道信息:", audioTracks[0].getSettings());
      try {
        const AudioContext = window.AudioContext || window.webkitAudioContext;
        if (!AudioContext) {
          console.warn("浏览器不支持AudioContext");
          return;
        }
        const audioContext = new AudioContext();
        const analyser = audioContext.createAnalyser();
        const microphone = audioContext.createMediaStreamSource(this.cameraStream);
        microphone.connect(analyser);
        analyser.fftSize = 256;
        const bufferLength = analyser.frequencyBinCount;
        const dataArray = new Uint8Array(bufferLength);
        let silenceCounter = 0;
        const checkAudio = () => {
          if (this.isRecording)
            return;
          analyser.getByteFrequencyData(dataArray);
          let sum = 0;
          for (let i = 0; i < bufferLength; i++) {
            sum += dataArray[i];
          }
          const average = sum / bufferLength;
          if (average > 10) {
            console.log("检测到音频输入，音量:", average);
            silenceCounter = 0;
          } else {
            silenceCounter++;
            if (silenceCounter > 10) {
              console.warn("持续检测不到音频输入，可能麦克风未正常工作");
              silenceCounter = 0;
            }
          }
          requestAnimationFrame(checkAudio);
        };
        checkAudio();
      } catch (e) {
        console.error("音频测试失败:", e);
      }
    },
    // 添加新方法：尝试单独获取音频
    tryGetAudioOnly() {
      navigator.mediaDevices.getUserMedia({ audio: true }).then((audioStream) => {
        if (this.cameraStream) {
          const videoTrack = this.cameraStream.getVideoTracks()[0];
          const audioTrack = audioStream.getAudioTracks()[0];
          const combinedStream = new MediaStream();
          if (videoTrack)
            combinedStream.addTrack(videoTrack);
          if (audioTrack)
            combinedStream.addTrack(audioTrack);
          this.cameraStream = combinedStream;
          const videoElement = this.$refs.userCameraVideo;
          if (videoElement) {
            videoElement.srcObject = combinedStream;
            videoElement.muted = true;
          }
          console.log("成功合并音频和视频轨道");
        } else {
          console.warn("没有视频流可合并");
        }
      }).catch((err) => {
        console.error("单独获取音频失败:", err);
      });
    },
    // 添加新方法：显示权限对话框
    showPermissionDialog(permissionType) {
      common_vendor.index.showModal({
        title: "需要权限",
        content: `请允许使用${permissionType}权限，否则可能影响面试功能`,
        confirmText: "去设置",
        success: (res) => {
          if (res.confirm) {
            common_vendor.index.openSetting({
              success: (settingRes) => {
                console.log("设置页面打开成功", settingRes);
              }
            });
          }
        }
      });
    }
  }
};
function _sfc_render(_ctx, _cache, $props, $setup, $data, $options) {
  return common_vendor.e({
    a: $data.videoUrl,
    b: common_vendor.o((...args) => $options.handleVideoError && $options.handleVideoError(...args)),
    c: common_vendor.o((...args) => $options.handleVideoEnded && $options.handleVideoEnded(...args)),
    d: common_vendor.o((...args) => $options.handleTimeUpdate && $options.handleTimeUpdate(...args)),
    e: $data.currentSubtitle
  }, $data.currentSubtitle ? {
    f: common_vendor.t($data.currentSubtitle)
  } : {}, {
    g: $data.showAnswerButton
  }, $data.showAnswerButton ? {
    h: common_vendor.o((...args) => $options.handleAnswerButtonClick && $options.handleAnswerButtonClick(...args))
  } : {}, {
    i: $data.useMiniProgramCameraComponent
  }, $data.useMiniProgramCameraComponent ? {
    j: common_vendor.o((...args) => $options.handleCameraError && $options.handleCameraError(...args))
  } : {}, {
    k: $data.loading
  }, $data.loading ? {} : {}, {
    l: $data.showDebugInfo
  }, $data.showDebugInfo ? common_vendor.e({
    m: $data.assistantResponse
  }, $data.assistantResponse ? {
    n: common_vendor.t($data.assistantResponse)
  } : {}, {
    o: $data.audioTranscript
  }, $data.audioTranscript ? {
    p: common_vendor.t($data.audioTranscript)
  } : {}, {
    q: common_vendor.f($data.processedResponses, (item, index, i0) => {
      return common_vendor.e({
        a: item.role
      }, item.role ? {
        b: common_vendor.t(item.role)
      } : {}, {
        c: item.transcript
      }, item.transcript ? {
        d: common_vendor.t(item.transcript)
      } : {}, {
        e: index
      });
    })
  }) : {}, {
    r: $data.showStopRecordingButton
  }, $data.showStopRecordingButton ? {
    s: common_vendor.o((...args) => $options.stopRecordingAnswer && $options.stopRecordingAnswer(...args))
  } : {}, {
    t: $data.isRecording
  }, $data.isRecording ? {} : {}, {
    v: $data.showStartRecordingButton
  }, $data.showStartRecordingButton ? {
    w: common_vendor.o((...args) => $options.handleStartRecordingClick && $options.handleStartRecordingClick(...args))
  } : {});
}
const MiniProgramPage = /* @__PURE__ */ common_vendor._export_sfc(_sfc_main, [["render", _sfc_render], ["__scopeId", "data-v-464e78c6"]]);
wx.createPage(MiniProgramPage);
